read "MHLBBGCD.mpl";
read "TestQuestions.mpl";

test1 := true;
test2 := true;
test3 := true;

if test1 = true then

print("Benchmark 1 test begin");

 totalTime1 := [seq(time()-time(),i=1..10)];
 evalTime1 := [seq(0,i=1..10)];
  terms1 := [seq(0,i=1..10)];

for i from 2 to 11 do

printf("n=%d\n",2*i);

   resetTimes();
   resetTimes2();
   GetEvalCounter := 0;
   evalCounter := 0;


   #n := 2^i;
   n := 2*i;
   X := [x||(1..n)]; Y := [y||(1..n)]; Z := [op(X),op(Y)];
   X2 := [X[1],X[2],op(Y[3..n])];


   b1 := bbVanCFast1(n);
   b2 := bbVanCFast2(n);

   probeCount := 0;

    st := time():
    g := BBMGCD(b1,b2,Z,2);
    #print(g);
    totalTime1[i-1] :=  time() - st;
    evalTime1[i-1] := probeCount;
    terms1[i-1] := nops(g);
    print(factor(g));

    #printTimings();
    #printTimings2();
    #print(totalTime1[i-1]);
    #print(probeCount);
    #print(figureOut);
    #print(GetEvalCounter);
    #print(evalCounter);

od;
fi;

#test set 2
if test2 = true then
   n := 5;
   X := [x||(1..n)];
  s := [10, 100 ,250, 500 ,1000]; t := [1000, 500, 250, 100, 10];

  print("Benchmark 2 test begin");

   totalTime2 := [seq(time()-time(),i=1..5)];
   evalTime2 := [seq(time()-time(),i=1..5)];

   for i from 1 to nops(s) do

   printf("test number %d\n",i);

     resetTimes();
     resetTimes2();
     GetEvalCounter := 0;
     evalCounter := 0;

     dd := 10;

      g := randpoly(X,terms=s[i],degree=dd):
      abar := randpoly(X,terms=t[i],degree=dd):
      bbar := randpoly(X,terms=t[i],degree=dd):

      probeCount := 0;

      ba := bbpolygen(abar,g,X):
      bb := bbpolygen(bbar,g,X):

      st := time():
      g2 := BBMGCD(ba,bb,X,0):
      print(g2);
      totalTime2[i] :=  time() - st;
      #evalTime2[i] := probeCount;

       gTrue := expand(g*gcd(abar,bbar)):
       #print(g2);
       g2 := expand(denom(g2)*g2):
       #print(g2);
       if gTrue = g2 or gTrue = -g2 then
          print("pass");
       else
          print("fail");
       fi;
   od:

fi;

#test set 3
if test3 = true then
   n := 5; m := 10;
   X := [x||(1..n)];

   print("Benchmark 3 test begin");

   totalTime3 := [seq(time()-time(),i=1..m)];
   evalTime3 := [seq(time()-time(),i=1..m)];

   for i from 1 to m do

   printf("m=%d\n",i);

     resetTimes();
     resetTimes2();
     GetEvalCounter := 0;
     evalCounter := 0;

      probeCount := 0;

      b1 :=  bbGarrettTest1(n,i,1):
      b2 :=  bbGarrettTest1(n,i,2):

      st := time():
      g2 := BBMGCD(b1,b2,X,0):
      print(g2);
      totalTime3[i] :=  time() - st;
      #evalTime3[i] := probeCount;

      #print(factor(g2));

   od:

fi;

print(totalTime1);
#print(evalTime1);
#print(terms1);

print(totalTime2);
#print(evalTime2);

print(totalTime3);
#print(evalTime3);

